<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>LibGE: src/GEGrammar.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="cropped-BDS-Logo-1.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibGE
   &#160;<span id="projectnumber">0.31.0</span>
   </div>
   <div id="projectbrief">A c++ GE implementation</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">GEGrammar.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_g_e_grammar_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// GEGrammar.h -*- C++ -*-</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef _GEGRAMMAR_H_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define _GEGRAMMAR_H_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">/* This class implements the standard GE mapping process. It implements the  */</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* virtual methods genotype2phenotype and phenotype2genotype, and the        */</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">/* standard GE wrapping operator.                                            */</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="lib_g_edefs_8h.html">libGEdefs.h</a>&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include&lt;stack&gt;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include&lt;vector&gt;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_c_f_grammar_8h.html">CFGrammar.h</a>&quot;</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_a_g_symbol_8h.html">AGSymbol.h</a>&quot;</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_a_g_look_up_8h.html">AGLookUp.h</a>&quot;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_a_g_derivation_tree_8h.html">AGDerivationTree.h</a>&quot;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_a_g_context_8h.html">AGContext.h</a>&quot;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">using namespace </span>std;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="class_g_e_grammar.html">   25</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_g_e_grammar.html">GEGrammar</a> : <span class="keyword">public</span> <a class="code" href="class_c_f_grammar.html">CFGrammar</a>{</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        <a class="code" href="class_g_e_grammar.html">GEGrammar</a>(<span class="keywordtype">bool</span> useAttributeGrammar=<span class="keyword">false</span>,<a class="code" href="class_a_g_look_up.html">AGLookUp</a>* lookup=NULL,<a class="code" href="class_a_g_context.html">AGContext</a>* context=NULL);</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <a class="code" href="class_g_e_grammar.html">GEGrammar</a>(<span class="keyword">const</span> <a class="code" href="class_genotype.html">Genotype</a> &amp;,<span class="keywordtype">bool</span> useAttributeGrammar=<span class="keyword">false</span>,<a class="code" href="class_a_g_look_up.html">AGLookUp</a>* lookup=NULL,<a class="code" href="class_a_g_context.html">AGContext</a>* context=NULL);</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <a class="code" href="class_g_e_grammar.html">GEGrammar</a>(<span class="keyword">const</span> <a class="code" href="class_phenotype.html">Phenotype</a> &amp;,<span class="keywordtype">bool</span> useAttributeGrammar=<span class="keyword">false</span>,<a class="code" href="class_a_g_derivation_tree.html">AGDerivationTree</a>* newAGDTree=NULL,<a class="code" href="class_a_g_look_up.html">AGLookUp</a>* lookup=NULL,<a class="code" href="class_a_g_context.html">AGContext</a>* context=NULL);</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <a class="code" href="class_g_e_grammar.html">GEGrammar</a>(<span class="keyword">const</span> <a class="code" href="class_g_e_grammar.html">GEGrammar</a>&amp;);</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="keyword">virtual</span> ~<a class="code" href="class_g_e_grammar.html">GEGrammar</a>();</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getMaxWraps() <span class="keyword">const</span>;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        <span class="keywordtype">void</span> setMaxWraps(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <span class="keywordtype">bool</span> getUseAG() <span class="keyword">const</span>;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        <span class="keyword">const</span> <a class="code" href="class_tree.html">DerivationTree</a>* getDerivationTree();</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="keyword">const</span> <a class="code" href="class_a_g_derivation_tree.html">AGDerivationTree</a>* getAGDerivationTree() <span class="keyword">const</span>;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keyword">const</span> vector&lt;Production*&gt;* getProductions();                </div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        <span class="keyword">const</span> <a class="code" href="class_a_g_look_up.html">AGLookUp</a>* getAGLookUp() <span class="keyword">const</span>;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keyword">const</span> <a class="code" href="class_a_g_context.html">AGContext</a>* getAGContext() <span class="keyword">const</span>;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="class_g_e_grammar.html#a99547280331bbeb58afe3acf01108c0a">   41</a></span>&#160;        vector&lt;Production*&gt; <a class="code" href="class_g_e_grammar.html#a99547280331bbeb58afe3acf01108c0a">productions</a>;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="keywordtype">bool</span> genotype2Phenotype();</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <span class="keywordtype">bool</span> phenotype2Genotype();</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        <span class="keywordtype">void</span> buildDTree(<a class="code" href="class_tree.html">DerivationTree</a>&amp;, vector&lt;Production*&gt;::iterator&amp;);</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        <span class="keyword">virtual</span> <a class="code" href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28a">AGMapState</a> buildAGTree(<span class="keywordtype">bool</span> init,<a class="code" href="class_tree.html">AGTree</a> &amp;currentNode, <span class="keyword">const</span> <a class="code" href="class_symbol.html">Symbol</a>* nodeSym, <a class="code" href="class_a_g_context.html">AGContext</a>&amp; context, stack&lt;const Symbol*&gt;&amp; nonterminals,</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;                Genotype::iterator&amp; genoIt, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; newEffectiveSize, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; wraps, <span class="keywordtype">bool</span>&amp; gotToUseWrap, <span class="keywordtype">int</span> prevProdIndex, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> backtrack,</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;                <span class="keyword">const</span> <span class="keywordtype">bool</span> growMethod=<span class="keyword">false</span>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxDepth=0, <span class="keywordtype">int</span> genoLenSoFar=0);</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <span class="keyword">virtual</span> <a class="code" href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28a">AGMapState</a> getAGInitProductionSet(<a class="code" href="class_rule.html">Rule</a>* &amp;rulePtr, <a class="code" href="class_tree.html">AGTree</a>&amp; currentAGNode, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxDepth, <span class="keyword">const</span> <span class="keywordtype">bool</span> growMethod, vector&lt;int&gt; &amp;possibleRules);</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;                <span class="keywordtype">int</span> chooseProduction(<span class="keywordtype">int</span> codon, <a class="code" href="class_rule.html">Rule</a> *rulePtr, <a class="code" href="class_tree.html">AGTree</a>* =NULL);</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="keyword">virtual</span> <a class="code" href="class_symbol.html">Symbol</a>* createSymbol(<span class="keyword">const</span> <a class="code" href="class_symbol.html">Symbol</a>&amp;, <span class="keywordtype">bool</span> =<span class="keyword">false</span>);</div><div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="class_g_e_grammar.html#ac4484e523fde253ea6ac22a1d79846c5">   51</a></span>&#160;                <span class="keywordtype">bool</span> <a class="code" href="class_g_e_grammar.html#ac4484e523fde253ea6ac22a1d79846c5">useAG</a>;</div><div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="class_g_e_grammar.html#a10ba4c1a8dcd16f319c23279d9bd4533">   52</a></span>&#160;                <a class="code" href="class_a_g_look_up.html">AGLookUp</a>* <a class="code" href="class_g_e_grammar.html#a10ba4c1a8dcd16f319c23279d9bd4533">agLookUp</a>;  </div><div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="class_g_e_grammar.html#a4b1bcd828a58754db1ce6f42fd07263f">   53</a></span>&#160;        <a class="code" href="class_a_g_context.html">AGContext</a>* <a class="code" href="class_g_e_grammar.html#a4b1bcd828a58754db1ce6f42fd07263f">agContext</a>;</div><div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="class_g_e_grammar.html#a72b97d5b8d879aee9f78870c8e96d940">   54</a></span>&#160;        <a class="code" href="class_a_g_derivation_tree.html">AGDerivationTree</a>* <a class="code" href="class_g_e_grammar.html#a72b97d5b8d879aee9f78870c8e96d940">agDtree</a>;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <span class="keywordtype">bool</span> genotype2Phenotype(<span class="keyword">const</span> <span class="keywordtype">bool</span>);</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="keywordtype">int</span> genotype2PhenotypeStep(stack&lt;const Symbol*&gt;&amp;,Genotype::iterator,<span class="keywordtype">bool</span>, <a class="code" href="class_rule.html">Rule</a>* &amp;, <span class="keywordtype">int</span>&amp;, <a class="code" href="class_tree.html">AGTree</a>* =NULL);                </div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keywordtype">bool</span> geno2phenoStepDecision(<span class="keywordtype">int</span> result, Genotype::iterator&amp; genoIt, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; newEffectiveSize, <span class="keywordtype">bool</span>&amp; gotToUseWrap, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; wraps);</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxWraps;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;};</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclass_symbol_html"><div class="ttname"><a href="class_symbol.html">Symbol</a></div><div class="ttdef"><b>Definition:</b> Symbol.h:28</div></div>
<div class="ttc" id="aclass_c_f_grammar_html"><div class="ttname"><a href="class_c_f_grammar.html">CFGrammar</a></div><div class="ttdef"><b>Definition:</b> CFGrammar.h:25</div></div>
<div class="ttc" id="aclass_phenotype_html"><div class="ttname"><a href="class_phenotype.html">Phenotype</a></div><div class="ttdef"><b>Definition:</b> Phenotype.h:29</div></div>
<div class="ttc" id="aclass_g_e_grammar_html_a99547280331bbeb58afe3acf01108c0a"><div class="ttname"><a href="class_g_e_grammar.html#a99547280331bbeb58afe3acf01108c0a">GEGrammar::productions</a></div><div class="ttdeci">vector&lt; Production * &gt; productions</div><div class="ttdef"><b>Definition:</b> GEGrammar.h:41</div></div>
<div class="ttc" id="a_a_g_symbol_8h_html"><div class="ttname"><a href="_a_g_symbol_8h.html">AGSymbol.h</a></div></div>
<div class="ttc" id="aclass_genotype_html"><div class="ttname"><a href="class_genotype.html">Genotype</a></div><div class="ttdef"><b>Definition:</b> Genotype.h:28</div></div>
<div class="ttc" id="a_a_g_derivation_tree_8h_html"><div class="ttname"><a href="_a_g_derivation_tree_8h.html">AGDerivationTree.h</a></div></div>
<div class="ttc" id="alib_g_edefs_8h_html"><div class="ttname"><a href="lib_g_edefs_8h.html">libGEdefs.h</a></div></div>
<div class="ttc" id="a_a_g_look_up_8h_html"><div class="ttname"><a href="_a_g_look_up_8h.html">AGLookUp.h</a></div></div>
<div class="ttc" id="a_c_f_grammar_8h_html"><div class="ttname"><a href="_c_f_grammar_8h.html">CFGrammar.h</a></div></div>
<div class="ttc" id="aclass_g_e_grammar_html_a10ba4c1a8dcd16f319c23279d9bd4533"><div class="ttname"><a href="class_g_e_grammar.html#a10ba4c1a8dcd16f319c23279d9bd4533">GEGrammar::agLookUp</a></div><div class="ttdeci">AGLookUp * agLookUp</div><div class="ttdef"><b>Definition:</b> GEGrammar.h:52</div></div>
<div class="ttc" id="aclass_g_e_grammar_html_a72b97d5b8d879aee9f78870c8e96d940"><div class="ttname"><a href="class_g_e_grammar.html#a72b97d5b8d879aee9f78870c8e96d940">GEGrammar::agDtree</a></div><div class="ttdeci">AGDerivationTree * agDtree</div><div class="ttdef"><b>Definition:</b> GEGrammar.h:54</div></div>
<div class="ttc" id="a_a_g_symbol_8h_html_a957d51e6618189668fefc29a518bf28a"><div class="ttname"><a href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28a">AGMapState</a></div><div class="ttdeci">AGMapState</div><div class="ttdef"><b>Definition:</b> AGSymbol.h:32</div></div>
<div class="ttc" id="aclass_a_g_look_up_html"><div class="ttname"><a href="class_a_g_look_up.html">AGLookUp</a></div><div class="ttdef"><b>Definition:</b> AGLookUp.h:22</div></div>
<div class="ttc" id="aclass_g_e_grammar_html"><div class="ttname"><a href="class_g_e_grammar.html">GEGrammar</a></div><div class="ttdef"><b>Definition:</b> GEGrammar.h:25</div></div>
<div class="ttc" id="a_a_g_context_8h_html"><div class="ttname"><a href="_a_g_context_8h.html">AGContext.h</a></div></div>
<div class="ttc" id="aclass_rule_html"><div class="ttname"><a href="class_rule.html">Rule</a></div><div class="ttdef"><b>Definition:</b> Rule.h:23</div></div>
<div class="ttc" id="aclass_a_g_derivation_tree_html"><div class="ttname"><a href="class_a_g_derivation_tree.html">AGDerivationTree</a></div><div class="ttdef"><b>Definition:</b> AGDerivationTree.h:22</div></div>
<div class="ttc" id="aclass_g_e_grammar_html_a4b1bcd828a58754db1ce6f42fd07263f"><div class="ttname"><a href="class_g_e_grammar.html#a4b1bcd828a58754db1ce6f42fd07263f">GEGrammar::agContext</a></div><div class="ttdeci">AGContext * agContext</div><div class="ttdef"><b>Definition:</b> GEGrammar.h:53</div></div>
<div class="ttc" id="aclass_g_e_grammar_html_ac4484e523fde253ea6ac22a1d79846c5"><div class="ttname"><a href="class_g_e_grammar.html#ac4484e523fde253ea6ac22a1d79846c5">GEGrammar::useAG</a></div><div class="ttdeci">bool useAG</div><div class="ttdef"><b>Definition:</b> GEGrammar.h:51</div></div>
<div class="ttc" id="aclass_tree_html"><div class="ttname"><a href="class_tree.html">Tree&lt; const Symbol * &gt;</a></div></div>
<div class="ttc" id="aclass_a_g_context_html"><div class="ttname"><a href="class_a_g_context.html">AGContext</a></div><div class="ttdef"><b>Definition:</b> AGContext.h:28</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
